﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using System.Windows.Controls.Primitives;
using Telerik.Windows.Controls.GridView;
using System.Windows.Threading;

namespace RadGridViewHideRowDetailesGrid
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private List<RadGridView> childGrids = new List<RadGridView>();
		public MainWindow()
		{
			InitializeComponent();
			this.clubsGrid.LoadingRowDetails += clubsGrid_LoadingRowDetails;
			this.clubsGrid.Loaded += clubsGrid_Loaded;
		}

		void clubsGrid_Loaded(object sender, RoutedEventArgs e)
		{
			ScrollBar verticalScrollBar1 = this.clubsGrid.ChildrenOfType<ScrollBar>().Where(b => b.Name == "PART_HorizontalScrollBar").FirstOrDefault();
			verticalScrollBar1.ValueChanged += new RoutedPropertyChangedEventHandler<double>(verticalScrollBar1_ValueChanged);
		}

		void clubsGrid_LoadingRowDetails(object sender, GridViewRowDetailsEventArgs e)
		{
			Club dataContext = e.Row.DataContext as Club;
			if (!dataContext.IsChildGridSet)
			{
				dataContext.IsChildGridSet = true;
				RadGridView childGrid = e.DetailsElement.FindName("playersGrid") as RadGridView;
				childGrids.Add(childGrid);
			}

		}

		private void verticalScrollBar1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			foreach (var grid in this.childGrids)
			{
				if (grid != null)
				{
					(grid.ChildrenOfType<GridViewScrollViewer>().FirstOrDefault()).ScrollToHorizontalOffset(e.NewValue);
				}
			}
		}
	}
}
